% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hooks.R
\name{default_hook}
\alias{default_hook}
\title{Default \code{hook} argument to \code{\link[=make]{make()}}.}
\usage{
default_hook(code)
}
\arguments{
\item{code}{Placeholder for the code to build a target/import.}
}
\value{
A function that you can supply to the \code{hook} argument
of \code{\link[=make]{make()}}.
}
\description{
Most users do not need to micromanage hooks.
}
\examples{
\dontrun{
test_with_dir("Quarantine side effects.", {
load_basic_example() # Get the code with drake_example("basic").
# Everything gets built normally.
make(my_plan, hook = default_hook)
cached() # List the cached targets and imports.
})
}
}
